=== debian/changelog ===
ros-iron-ouster-ros (0.10.4-1jammy) jammy; urgency=high

  * breaking: publish PCL point clouds destaggered.
  * introduced a new launch file parameter ``ptp_utc_tai_offset`` which represent offset in seconds
    to be applied to all ROS messages the driver generates when ``TIME_FROM_PTP_1588`` timestamp mode
    is used.
  * fix: destagger columns timestamp when generating destaggered point clouds.
  * Use the local copy of the LICENSE file during install
  * Contributors: Ussama Naal

 -- Ussama Naal <ussama.naal@ouster.io>  Thu, 31 Aug 2023 07:00:00 -0000

ros-iron-ouster-ros (0.10.3-1jammy) jammy; urgency=high

  * Add per package LICENSE file
  * manifest symbolic links as files
  * Contributors: Ussama Naal

 -- ouster developers <oss@ouster.io>  Tue, 15 Aug 2023 07:00:00 -0000

ros-iron-ouster-ros (0.10.2-1jammy) jammy; urgency=high

  * SW-5396: publish point cloud in destaggered form (#182)
    * Quick implementtion of cloud destaggering
    * Perform destaggering of point clouds during the copy + add a viz-reliable file + wrap all classes in ouster_ros
    * Update changelog and version
    * Reformat changelog
  * SW-5345: merge-ouster-srvs into ouster-msgs (#176)
    * Merge ouster-srvs into ouster-msgs package + Update dockerfile + Other fixes and code improvements
    * Update launch file name within the dockerfile
    * Update CHANGELOG.txt
    * Update ouster_ros package version to highlight the breadking change due obseleting ouster_srvs
    * Use angle brackets for external headers
    * Remove unused library include
    * Remove unused launch params in sensor_mtp.launch
    * Fix the table of contents
  * SW-5167: follow ups from SW-5167-fix-black-columns-when-recording-under-ros-foxy (#163)
    * Initialize point_cloud_frame with an empty string + and expose point_cloud_frame through launch xml files +
    Remove unused/duplicate param definitions + Update descriptions
    * Correct the name of the node to be activated for merged node
  * ROS compatibility mode dual returns fix (#156)
    * Separately initialize vector elements
    * Update changelog and package version
    * Properly check for the write_text_to_file success
  * ROS2 compatibility mode (#146)
    * Factoring out Imu and Lidar packets handling
    * Added os_driver which combines os_sensor and os_cloud +
    Added required launch files +
    Better abstraction of classes +
    Simplified threading logic +
    Added thread safe implemention of ring buffer (not hooked yet)
    * Move down pragma once in the handlers
    * Adding unit tests for the ThreadSafeRingBuffer
    * Add one more case to the unit test of ThreadSafeRingBuffer
    * Quick hook up of the ThreadSafeRingBuffer for os_sensor and os_driver
    * Add an option to select the point_cloud frame
    * Keep transforms in Lidar Frame by default with option to switch
    * Formatting os_sensor and os_driver
    * Provide support for parsing the community driver params file with approprite launch file
    * Factor out tf transforms broadcast
    * Formatting imu and lidar packet handlers
    * Fix build issue
    * Incorporate LaserScan message composition
    * Refactor a bit and add the ability to process and publish point clouds and laser scans
    * Restor os_cloud_node ability to process point clouds
    * Parse proc_mask and hook to launch files and config
    * Add support for the selecting IMU + create topics/subs when their respective flags enabled
    * Reduce sync operations + restore sensor reset/reactivation
    * Add the ability to override current qos settings
    * Add minor note
    * More detailed explanation about the IMG node
    * Rename the file os_sensor_cloud_image_params to os_sensor_cloud_image_params.yaml and update corresponding launch files
    * Expose use_system_default_qos parameter to xml launch file and use proper defaults
    * Update minimal readme file and utilize os_driver by default +
    add proc_mask to xml file +
    Remove experminal marker from set_config and reset ros services
    * Update CHANGELOG.rst and package version
    * Apply && to accepted method of ThreadSafeRingBuffer +
    nits and code formatting
    * Add missing parameter declaration
    * Re-formatting CHANGELOG a bit
    * Added ImageProcessor to support IMG flag +
    Define new argument scan_ring
    * Expose scan_ring param and update relevant params description
    * Added notes to size(), empty(), full()
    * remove deprecated methods + naming nits
    * Update ChangeLog + Fix load_metadata_from_file
    * Try out building against Iron + revise sensor_mtp.launch
    * Correct the params file name + document params
    * Carry over fixes from foxy branch
    * Update README.md to mention compatibilty mode
  * SW-4997: Switch from using ROS timers to thread for polling lidar data (#140)
    * Switch from using ROS timers to thread for polling
    * Specify param defaults for non-required params
  * SW-4972: merge switching to static transform publisher contribution (#124)
    * use static tf broadcaster for ros2 (#112)
    * use separate params for tf frames
    * send static transforms once
    * Disable static transform publishers and update changelog and package version
    * Disable rviz static transform publisher
    * Remove rviz static transform publisher hack
    * Remove left out variables
    ---------
    Co-authored-by: Adam Aposhian <mailto:adam.l.aposhian@gmail.com>
  * SW-4859: enable having multiple components of same-type under same process (#108)
    * Remove the use of static vars within components
    * Resolve conflicts and update changelog and version
    * Fix a typo 'instance'
  * Drop service_msgs dep (#117)
  * SW-4924: Replace tf_prefix by sensor_frame lidar_frame and imu_frame parameters (#115)
    * deprecate tf_prefix from os_cloud (#96)
    Co-authored-by: Guillaume Doisy <mailto:guillaume@dexory.com>
    * Squashed commit of the following:
    commit 6280bfa1178bdee4fe695cb4752efd5ff15279db

